package com.seanchenxi.gwt.xmlrpc.client;

/**
 * Interface to an XML-RPC request made by a client.
 *
 * @param <T> the generic type
 */
public interface XmlRpcRequest<T> {

	/**
	 * Gets the method name.
	 *
	 * @return the method name
	 */
	String getMethodName();

	/**
	 * Gets the parameter count.
	 *
	 * @return the parameter count
	 */
	int getParameterCount();

	/**
	 * Gets the parameter.
	 *
	 * @param index the index
	 * @return the parameter
	 */
	Object getParameter(int index);

}
